1.题目描述:
Billboard
Time Limit: 20000/8000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 21405 Accepted Submission(s): 8821
Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.
On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.
Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.
When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.
If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).
Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
Input
There are multiple cases (no more than 40 cases).
The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.
Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
Sample Input
3 5 5
2
4
3
3
3
Sample Output
1
2
1
3
-1
Author
hhanger@zju
Source
HDOJ 2009 Summer Exercise(5)
Recommend
lcy | We have carefully selected several similar problems for you:
1542
1394
1828
1540
1255
2.题意概述:
有一块高h、宽度w的海报墙可以用来贴海报,接下来有n个海报,每个海报宽度是w_i,高度为1,并且小明每次都从最上面开始贴(意味着贴第i行时候,保证前i行都不能贴下这个海报),问你第i张海报贴完后位于第几行。煮个栗子:第i张先看第1行贴不贴得下,帖得下就贴,否则看第二行贴不贴得下,不行再....以此类推
3.解题思路:
首先题意明确说明尽量往上贴,也就是个贪心思想,很容易想到维护n行当前能贴的最大宽度w,但是当要贴宽度w_i时候,怎么确定贴在哪呢?通常的暴力做法是从第一行开始扫,判断当前行可贴宽度,这样下来n次海报复杂度是O(N^2)。显然有更优做法,可以考虑用线段树t[root].w维护以【t[root].l, t[root].r】为区间内可以贴的最大宽度,然后尽可能地,往左贴这样查询就和更新logN的。
4.AC代码:
#include <bits/stdc++.h>
#define INF 0x3f3f3f3f
#define maxn 200010
#define lson root << 1
#define rson root << 1 | 1
#define N 1111
#define eps 1e-6
#define pi acos(-1.0)
#define e exp(1.0)
using namespace std;
const int mod = 1e9 + 7;
typedef long long ll;
typedef unsigned long long ull;
struct tree
{
int l, r, w;
} t[maxn << 2];
void pushup(int root)
{
t[root].w = max(t[lson].w, t[rson].w);
}
void build(int val, int l, int r, int root)
{
t[root].l = l;
t[root].r = r;
t[root].w = 0;
if (l == r)
{
t[root].w = val;
return;
}
int mid = l + r >> 1;
build(val, l, mid, lson);
build(val, mid + 1, r, rson);
pushup(root);
}
int query(int val, int l, int r, int root)
{
if (l == r)
{
t[root].w -= val;
// pushup(root);
return l;
}
int mid = l + r >> 1;
int ans;
if (t[lson].w >= val)
ans = query(val, l, mid, lson);
else
ans = query(val, mid + 1, r, rson);
pushup(root);
return ans;
}
int main()
{
#ifndef ONLINE_JUDGE
freopen("in.txt", "r", stdin);
freopen("out.txt", "w", stdout);
long _begin_time = clock();
#endif
int h, w, n;
while (~scanf("%d%d%d", &h, &w, &n))
{
h = min(h, n);
build(w, 1, h, 1);
while (n--)
{
int x;
scanf("%d", &x);
if (t[1].w < x)
puts("-1");
else
printf("%d\n", query(x, 1, h, 1));
}
}
#ifndef ONLINE_JUDGE
long _end_time = clock();
printf("time = %ld ms.", _end_time - _begin_time);
#endif
return 0;
}
转载请注明原文地址: https://ju.6miu.com/read-675530.html